addHook("PlayerThink", function(player)
	if ((player.playerstate == PST_LIVE) and not (player.powers[pw_carry]) and (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "amy" or player.mo.skin == "fang" or player.mo.skin == "metalsonic" or player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "heavy" or player.mo.skin == "bomb" or player.mo.skin == "ray" or player.mo.skin == "shadow"))
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		if (not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_tailsfly]) and not (player.pflags & PF_BOUNCING))
			player.thrustfactor = 2*skins[player.mo.skin].thrustfactor
		elseif (not (P_IsObjectOnGround(player.mo)) and player.pflags & PF_BOUNCING)
			player.thrustfactor = 8*skins[player.mo.skin].thrustfactor/3
		elseif (not (P_IsObjectOnGround(player.mo)) and player.powers[pw_tailsfly])
			if (player.speed > FixedMul(skins[player.mo.skin].normalspeed/2, player.mo.scale) and player.cmd.sidemove)
				player.thrustfactor = 4*skins[player.mo.skin].thrustfactor
			else
				player.thrustfactor = skins[player.mo.skin].thrustfactor
			end
		elseif (player.mo.skin != "heavy" and player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo))
			player.thrustfactor = skins[player.mo.skin].thrustfactor/2
		elseif (player.mo.skin == "heavy" and player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo))
			player.thrustfactor = 0
		else
			player.thrustfactor = skins[player.mo.skin].thrustfactor
		end
		if (P_IsObjectOnGround(player.mo))
			player.charflags = $|SF_RUNONWATER
		else
			player.charflags = $ & ~SF_RUNONWATER
		end
		if (player.secondjump == UINT8_MAX and player.pflags & PF_THOKKED and not (player.charflags & SF_NOJUMPSPIN))
			player.mo.state = S_PLAY_JUMP
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~(PF_SPINNING|PF_THOKKED|PF_SHIELDABILITY)
			player.secondjump = 0
		end
		if (not (P_IsObjectOnGround(player.mo)) and player.pflags & PF_JUMPED and (player.pflags & PF_THOKKED or player.pflags & PF_SHIELDABILITY) and ((player.mo.state == S_PLAY_JUMP and not (player.charflags & SF_NOJUMPSPIN)) or player.mo.state == S_PLAY_ROLL or (player.mo.skin == "espio" and player.mo.state == S_ESPIO_ROLL) or (player.mo.skin == "bomb" and (player.mo.state == S_BOMB_TOPSPIN or player.mo.state == S_BOMB_TOPSPIN_FAST))))
			if (player.mo.skin == "mighty" and not (player.pflags & PF_SHIELDABILITY) and player.mo.state != S_PLAY_JUMP)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $ | PF_JUMPED
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
					elseif not (player.mo.eflags & MFE_UNDERWATER) and (player.powers[pw_super] or player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER and (player.powers[pw_super] or player.powers[pw_sneakers]))
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					end
				end
			elseif (player.mo.skin != "bomb" and not (player.pflags & PF_SHIELDABILITY and player.powers[pw_shield] == SH_BUBBLEWRAP))
				player.pflags = $ | PF_SPINNING | PF_THOKKED
			elseif (player.mo.skin == "bomb")
				player.pflags = $ | PF_JUMPED
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
			elseif (player.pflags & PF_SHIELDABILITY and player.powers[pw_shield] == SH_BUBBLEWRAP)
				player.pflags = $ | PF_JUMPED|PF_THOKKED
				player.pflags = $ & ~PF_SPINNING
			end
		elseif (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH)
			if (player.pflags & PF_JUMPED and player.mo.skin != "heavy")
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
			elseif not (player.mo.skin == "heavy" and P_IsObjectOnGround(player.mo)) and not (player.mo.state == S_PLAY_SPINDASH) and not (player.mo.skin == "charmy" and (player.mo.state == S_CHARMY_ASCENT_CHARGE or player.mo.state == S_CHARMY_STINGER_CHARGE))
				if (player.speed < FixedMul(5<<FRACBITS, player.mo.scale) and P_IsObjectOnGround(player.mo))
					player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
					if (player.mo.state != S_PLAY_STND)
						player.mo.state = S_PLAY_STND
						P_InstaThrust(player.mo, player.mo.angle, 0)
					end
				elseif ((player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "shadow") and player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and player.skidtime and (player.mo.state == S_PLAY_ROLL or (player.mo.skin == "espio" and player.mo.state == S_ESPIO_ROLL)))
					player.mo.state = S_PLAY_SPINDASH
					player.pflags = $|PF_STARTDASH|PF_SPINNING
					player.pflags = $ & ~PF_THOKKED
					P_InstaThrust(player.mo, player.mo.angle, 0)
					S_StartSound(player.mo, sfx_spndsh)
					player.dashspeed = player.mindash
				else
					player.pflags = $ | PF_THOKKED
				end
			end
			if ((player.mo.skin == "vector" and player.cmd.buttons & BT_SPIN) or player.pflags & PF_JUMPED or not (P_IsObjectOnGround(player.mo)))
				player.normalspeed = skins[player.mo.skin].normalspeed
			else
				player.normalspeed = 0
			end
			if (P_IsObjectOnGround(player.mo) and not (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE))
				P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
			end
		elseif (player.mo.skin != "heavy" and (player.mo.state == S_PLAY_SPINDASH or (player.mo.skin == "charmy" and (player.mo.state == S_CHARMY_STINGER_CHARGE or player.mo.state == S_CHARMY_ASCENT_CHARGE)) or (player.mo.skin == "vector" and player.mo.state == S_VECTOR_SPINDASH)))
			player.pflags = $ & ~PF_THOKKED
		elseif (player.mo.skin == "heavy" and player.pflags & PF_SPINNING and not (P_IsObjectOnGround(player.mo)))
			player.pflags = $|PF_THOKKED
		elseif (player.mo.skin != "heavy" and (player.powers[pw_sneakers] or player.powers[pw_super]))
			if (player.mo.skin == "espio" and player.mo.state == S_PLAY_CLIMB)
				player.normalspeed = 7*skins[player.mo.skin].normalspeed/20
			else
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "espio" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "bomb" or player.mo.skin == "shadow")
				if (player.mo.eflags & MFE_UNDERWATER)
					player.mindash = 30*FRACUNIT
					player.maxdash = 36*FRACUNIT
				else
					player.mindash = 60*FRACUNIT
					player.maxdash = 72*FRACUNIT
				end
			end
			if (player.powers[pw_super])
				player.runspeed = 29*(36*FRACUNIT)/32
			else
				player.runspeed = 29*(60*FRACUNIT)/32
			end
		else
			if (player.mo.skin == "espio" and player.mo.state == S_PLAY_CLIMB)
				player.normalspeed = 7*skins[player.mo.skin].normalspeed/12
			else
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "espio" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "bomb" or player.mo.skin == "shadow")
				if (player.mo.eflags & MFE_UNDERWATER)
					player.mindash = 18*FRACUNIT
					player.maxdash = 36*FRACUNIT
				else
					player.mindash = 36*FRACUNIT
					player.maxdash = 72*FRACUNIT
				end
			end
			if (player.mo.skin == "heavy")
				player.runspeed = 24*FRACUNIT
			else
				player.runspeed = 29*(36*FRACUNIT)/32
			end
		end
		if (not (P_IsObjectOnGround(player.mo)) and (player.pflags & PF_JUMPED or player.pflags & PF_BOUNCING) and (player.mo.momz*P_MobjFlip(player.mo) < 0) and not (player.pflags & PF_GLIDING) and not (player.powers[pw_tailsfly]) and not (player.secondjump == 2 and player.mo.skin == "metalsonic") and not (player.mo.eflags & MFE_GOOWATER))
			if (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.momz = $+FRACUNIT/4
			else
				player.mo.momz = $-FRACUNIT/4
			end
		end
		if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.forwardmove or player.cmd.sidemove) and not (player.pflags & PF_SPINNING) and not (player.skidtime) and player.mo.state != S_PLAY_MELEE_LANDING and player.mo.state != S_PLAY_BOUNCE_LANDING and player.mo.skin != "heavy")
			if ((not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and player.speed >= player.runspeed) or (not (player.mo.eflags & MFE_UNDERWATER) and player.powers[pw_super] and player.speed >= 5*player.runspeed/3) or (player.mo.eflags & MFE_UNDERWATER and not (player.powers[pw_super]) and player.speed >= player.runspeed/2) or (player.mo.eflags & MFE_UNDERWATER and player.powers[pw_super] and player.speed >= 5*player.runspeed/6))
				if ((player.speed <= 72*FRACUNIT and not (player.mo.eflags & MFE_UNDERWATER)) or (player.speed <= 36*FRACUNIT and player.mo.eflags & MFE_UNDERWATER))
					player.mo.friction = FRACUNIT
					if (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE)
						P_Thrust(player.mo,R_PointToAngle2(0, 0, player.rmomx, player.rmomy), (FRACUNIT/4))
					else
						P_Thrust(player.mo,R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
					end
				elseif ((player.speed >= 72*FRACUNIT and not (player.mo.eflags & MFE_UNDERWATER)) or (player.speed >= 36*FRACUNIT and player.mo.eflags & MFE_UNDERWATER))
					player.mo.friction = 29*(FRACUNIT)/32
				end
			elseif ((not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and player.speed <= player.runspeed) or (not (player.mo.eflags & MFE_UNDERWATER) and player.powers[pw_super] and player.speed <= 5*player.runspeed/3) or (player.mo.eflags & MFE_UNDERWATER and not (player.powers[pw_super]) and player.speed <= player.runspeed/2) or (player.mo.eflags & MFE_UNDERWATER and player.powers[pw_super] and player.speed <= 5*player.runspeed/6))
				player.mo.friction = 29*FRACUNIT/32
			end
		elseif (player.mo.skin == "heavy" or not ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.forwardmove or player.cmd.sidemove) and not (player.pflags & PF_SPINNING) and not (player.skidtime)))
			player.mo.friction = 29*(FRACUNIT)/32
		end
		if (player.mo.skin != "heavy" and player.pflags & PF_JUMPED and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING)) and not (player.powers[pw_super]) and not (player.powers[pw_invulnerability]) and not (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE))
			player.pflags = $|PF_NOJUMPDAMAGE
		elseif (player.mo.skin != "heavy" and player.pflags & PF_JUMPED and (not ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING)) or player.powers[pw_super] or player.powers[pw_invulnerability] or (player.mo.skin == "metalsonic" and player.dashmode >= 3*TICRATE)))
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
		if not (P_IsObjectOnGround(player.mo)) and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING) or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH) and not (player.mo.skin == "metalsonic" and player.secondjump)
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~PF_SPINNING
			if (player.mo.skin == "amy")
				player.pflags = $ & ~PF_THOKKED
			end
			if (player.mo.momz*P_MobjFlip(player.mo) > 0)
				player.mo.state = S_PLAY_SPRING
			elseif (player.mo.momz*P_MobjFlip(player.mo) <= 0)
				player.mo.state = S_PLAY_FALL
			end
		end
		if (player.pflags & PF_SHIELDABILITY and not (P_IsObjectOnGround(player.mo)))
			if (player.mo.state != S_PLAY_JUMP and not (player.charflags & SF_NOJUMPSPIN))
				player.mo.state = S_PLAY_JUMP
			elseif (player.mo.state != S_PLAY_ROLL and player.charflags & SF_NOJUMPSPIN)
				player.mo.state = S_PLAY_ROLL
			end
		end
		if (player.mo.skin == "sonic")
			if (player.powers[pw_super] or player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
				if (player.speed < 60*FRACUNIT)
					player.actionspd = 60*FRACUNIT
				elseif (player.speed >= 60*FRACUNIT and player.speed < 72*FRACUNIT)
					player.actionspd = player.speed+(6*FRACUNIT)
				elseif (player.speed >= 72*FRACUNIT)
					player.actionspd = 72*FRACUNIT
				end
			elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
				if (player.speed < 36*FRACUNIT)
					player.actionspd = 36*FRACUNIT
				elseif (player.speed >= 36*FRACUNIT and player.speed < 72*FRACUNIT)
					player.actionspd = player.speed + (6*FRACUNIT)
				elseif (player.speed >= 72*FRACUNIT)
					player.actionspd = 72*FRACUNIT
				end
			elseif (player.powers[pw_super] or player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
				if (player.speed < 30*FRACUNIT)
					player.actionspd = 30*FRACUNIT
				elseif (player.speed >= 30*FRACUNIT and player.speed < 36*FRACUNIT)
					player.actionspd = player.speed + (6*FRACUNIT)
				elseif (player.speed >= 36*FRACUNIT)
					player.actionspd = 36*FRACUNIT
				end
			elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
				if (player.speed < 18*FRACUNIT)
					player.actionspd = 18*FRACUNIT
				elseif (player.speed >= 18*FRACUNIT and player.speed < 36*FRACUNIT)
					player.actionspd = player.speed+(6*FRACUNIT)
				elseif (player.speed >= 36*FRACUNIT)
					player.actionspd = 36*FRACUNIT
				end
			end
		end
		if (player.mo.skin == "tails")
			if (not (P_IsObjectOnGround(player.mo)) and (player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLY_TIRED or player.mo.state == S_PLAY_SWIM))				
				if (player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN)
					player.mo.state = S_PLAY_JUMP
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					player.pflags = $ & ~PF_NOJUMPDAMAGE
				end
				if (player.mo.state != S_PLAY_FLY_TIRED)
					if (player.cmd.buttons & BT_JUMP)
						player.fly1 = 1
					else
						player.fly1 = 0
					end
				end
				if (player.powers[pw_tailsfly] > 3*TICRATE and not (player.powers[pw_super]))
					player.powers[pw_tailsfly] = 3*TICRATE
				end
			end
		end
		if (player.mo.skin == "knuckles")
			if player.momentumplusglidelast == nil
				player.momentumplusglidelast = 0
			end
			local gliding = player.pflags & PF_GLIDING
			local thokked = player.pflags & PF_THOKKED
			local exitglide = (player.momentumplusglidelast == 1 and not (gliding) and thokked)
			local landglide = (player.momentumplusglidelast == 2 and not (gliding|thokked))
			if ((exitglide or landglide) and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_GLIDE_LANDING))
				player.mo.momx = $*2
				player.mo.momy = $*2
				if (exitglide)
					if (player.mo.state != S_PLAY_JUMP)
						player.mo.state = S_PLAY_JUMP
						player.mo.momz = $/2
					end
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					player.pflags = $ & ~(PF_NOJUMPDAMAGE|PF_GLIDING)
				end
			end
			if (P_IsObjectOnGround(player.mo) and player.pflags & PF_GLIDING)
				player.mo.state = S_PLAY_GLIDE_LANDING
				S_StartSound(player.mo, sfx_s3k4c)
				player.pflags = $ & ~PF_GLIDING
				player.skidtime = 0
			end
			if (player.mo.state == S_PLAY_GLIDE_LANDING and player.speed <= skins[player.mo.skin].normalspeed)
				player.mo.friction = FRACUNIT
			end
			if gliding
				player.momentumplusglidelast = 1
			elseif exitglide
				player.momentumplusglidelast = 2
			elseif not(gliding|thokked)
				player.momentumplusglidelast = 0
			end
		end
		if (player.mo.skin == "amy")
			if (player.powers[pw_super])
				player.thokitem = MT_LHRT
				player.revitem = MT_LHRT
			else
				player.thokitem = MT_NULL
				player.revitem = MT_NULL
			end
			if (player.mo.state == S_PLAY_MELEE or player.mo.state == S_PLAY_MELEE_FINISH or player.mo.state == S_PLAY_TWINSPIN)
				player.charability2 = CA2_MELEE
				if (player.mo.state == S_PLAY_MELEE_FINISH)
					player.mo.state = S_PLAY_MELEE
					player.powers[pw_strong] = STR_MELEE
				end
			else
				player.charability2 = CA2_NONE
			end
			if (player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and (player.pflags & PF_JUMPED or (player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo)) or P_IsObjectOnGround(player.mo)) and player.mo.state != S_PLAY_MELEE and player.mo.state != S_PLAY_MELEE_FINISH and player.mo.state != S_PLAY_MELEE_LANDING and player.mo.state != S_PLAY_SUPER_TRANS1 and player.mo.state != S_PLAY_SUPER_TRANS2 and player.mo.state != S_PLAY_SUPER_TRANS3 and player.mo.state != S_PLAY_SUPER_TRANS4 and player.mo.state != S_PLAY_SUPER_TRANS5 and player.mo.state != S_PLAY_SUPER_TRANS6 and not (player.mo.state == S_PLAY_ROLL and player.pflags & PF_JUMPED and player.pflags & PF_SPINNING and player.pflags & PF_THOKKED))
				P_ResetPlayer(player)
				player.pflags = $|PF_THOKKED
				player.pflags = $ & ~(PF_SPINNING|PF_JUMPED)
				player.mo.state = S_PLAY_MELEE
				player.powers[pw_strong] = STR_MELEE
				player.drawangle = player.mo.angle
				player.skidtime = 0
				S_StartSound(player.mo, sfx_s3k42)
				if P_IsObjectOnGround(player.mo)
					player.mo.z = $+P_MobjFlip(player.mo)
					P_SetObjectMomZ(player.mo, player.mindash, false)
					if (P_MobjFlip(player.mo)*player.mo.pmomz < 0)
						player.mo.momz = $+player.mo.pmomz
					elseif (P_MobjFlip(player.mo)*player.mo.pmomz >= 0)
						player.mo.pmomz = 0
					end
				elseif not (P_IsObjectOnGround(player.mo))
					player.mo.z = $-P_MobjFlip(player.mo)
					P_SetObjectMomZ(player.mo, -(player.mindash), false)
					if (P_MobjFlip(player.mo)*player.mo.pmomz < 0)
						player.mo.momz = $-player.mo.pmomz
					elseif (P_MobjFlip(player.mo)*player.mo.pmomz >= 0)
						player.mo.pmomz = 0
					end
				end
				if (player.cmd.forwardmove or player.cmd.sidemove or (player.cmd.angleturn and (player.cmd.forwardmove or player.cmd.sidemove)))
					if (player.powers[pw_super] or player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 60*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
						elseif (player.speed >= 60*FRACUNIT and player.speed < 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed >= 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 72*FRACUNIT)
						end
					elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 36*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
						elseif (player.speed >= 36*FRACUNIT and player.speed < 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed >= 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 72*FRACUNIT)
						end
					elseif (player.powers[pw_super] or player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 30*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
						elseif (player.speed >= 30*FRACUNIT and player.speed < 36*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed >= 36*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
						end
					elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 18*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
						elseif (player.speed >= 18*FRACUNIT and player.speed < 36*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed >= 36*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
						end
					end
				end
			end
			if (player.mo.state == S_PLAY_MELEE_LANDING)
				player.mo.friction = FRACUNIT
				if (player.cmd.buttons & BT_SPIN and not (player.cmd.buttons & BT_JUMP) and player.speed > FixedMul(5<<FRACBITS, player.mo.scale))
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_SPINNING|PF_THOKKED
					S_StartSound(player.mo, sfx_spin)
				elseif (player.cmd.buttons & BT_JUMP)
					P_DoJump(player, false)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					S_StartSound(player.mo, sfx_jump)
				else
					player.mo.state = S_PLAY_STND
					player.pflags = $ & ~PF_SPINNING|PF_THOKKED
				end
			end
			if (P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING)
				player.pflags = $|PF_JUMPDOWN
				if (player.cmd.buttons & BT_JUMP and not (player.plusbuttons & BT_JUMP))
					P_DoJump(player, false)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					S_StartSound(player.mo, sfx_jump)
				end
			end
		end
		if (player.mo.skin == "fang")
			local fanglockon = P_LookForEnemies(player, false, true)
			local fangbullet = nil
			local fangbomb = nil
			if (fanglockon and fanglockon.valid)
				P_SpawnLockOn(player, fanglockon, mobjinfo[MT_LOCKON].spawnstate)
			end
			if player.momentumplusbouncelast == nil
				player.momentumplusbouncelast = false
			end
			if ((player.pflags & PF_BOUNCING and not (player.momentumplusbouncelast)) or (not (player.pflags & PF_BOUNCING) and player.momentumplusbouncelast) and (player.mo.state == S_PLAY_BOUNCE or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL))
				player.mo.momx = $*2
				player.mo.momy = $*2
				if (not (player.pflags & PF_BOUNCING) and player.momentumplusbouncelast and player.mo.state != S_PLAY_ROLL)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_THOKKED|PF_SPINNING
					player.pflags = $ & ~PF_BOUNCING
				end
			end
			if (player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and not (player.weapondelay) and (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR or player.pflags & PF_BOUNCING or player.pflags & PF_JUMPED or (player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo))) and player.mo.state != S_PLAY_FIRE and player.mo.state != S_PLAY_FIRE_FINISH and player.mo.state != S_PLAY_SUPER_TRANS1 and player.mo.state != S_PLAY_SUPER_TRANS2 and player.mo.state != S_PLAY_SUPER_TRANS3 and player.mo.state != S_PLAY_SUPER_TRANS4 and player.mo.state != S_PLAY_SUPER_TRANS5 and player.mo.state != S_PLAY_SUPER_TRANS6 and not (player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and player.pflags & PF_SPINNING and player.mo.state == S_PLAY_ROLL))
				player.mo.state = S_PLAY_FIRE
				player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED|PF_BOUNCING)
				if (player.powers[pw_super])
					player.weapondelay = 6
				else
					player.weapondelay = TICRATE/2
				end
				if not (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR)
					player.mo.momz = $/2
				end
				if (player.mo.eflags & MFE_JUSTHITFLOOR)
					if ((player.cmd.buttons & BT_SPIN or player.plusbuttons & BT_SPIN) and player.speed > FixedMul(5<<FRACBITS, player.mo.scale)) and not (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_SPINNING|PF_THOKKED
						S_StartSound(player.mo, sfx_spin)
					elseif (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
						P_DoJump(player, false)
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_STARTJUMP|PF_JUMPED|PF_THOKKED|PF_SPINNING
						S_StartSound(player.mo, sfx_jump)
					else
						player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED)
					end
				end
				if (fanglockon and fanglockon.valid)
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, fanglockon.x, fanglockon.y)
					fangbullet = P_SpawnPointMissile(player.mo, fanglockon.x, fanglockon.y, fanglockon.z, player.revitem, player.mo.x, player.mo.y, player.mo.z)
				end
				if not (fanglockon and fanglockon.valid)
					fangbullet = P_SpawnPointMissile(player.mo, player.mo.x + P_ReturnThrustX(nil, player.mo.angle, FRACUNIT), player.mo.y + P_ReturnThrustY(nil, player.mo.angle, FRACUNIT), player.mo.z, player.revitem, player.mo.x, player.mo.y, player.mo.z)
				end
			end
			if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH)
				player.pflags = $|PF_JUMPDOWN
				player.pflags = $ & ~PF_BOUNCING
				if (player.mo.eflags & MFE_JUSTHITFLOOR)
					if ((player.cmd.buttons & BT_SPIN or player.plusbuttons & BT_SPIN) and player.speed >= FixedMul(5<<FRACBITS, player.mo.scale)) and not (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_SPINNING|PF_THOKKED
						S_StartSound(player.mo, sfx_spin)
					elseif (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
						P_DoJump(player, false)
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_STARTJUMP|PF_JUMPED|PF_THOKKED|PF_SPINNING
						S_StartSound(player.mo, sfx_jump)
					else
						player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED)
					end
				end
				if not (player.weapondelay)
					player.pflags = $ & ~(PF_BOUNCING|PF_JUMPDOWN)
					if (P_IsObjectOnGround(player.mo))
						if ((player.cmd.buttons & BT_SPIN or player.plusbuttons & BT_SPIN) and player.speed > FixedMul(5<<FRACBITS, player.mo.scale)) and not (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
							player.mo.state = S_PLAY_ROLL
							player.pflags = $|PF_SPINNING|PF_THOKKED
							S_StartSound(player.mo, sfx_spin)
						elseif (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)
							P_DoJump(player, false)
							player.mo.state = S_PLAY_ROLL
							player.pflags = $|PF_STARTJUMP|PF_JUMPED|PF_THOKKED|PF_SPINNING
							S_StartSound(player.mo, sfx_jump)
						else
							player.pflags = $ & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED)
						end
					elseif not (P_IsObjectOnGround(player.mo))
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_JUMPED|PF_THOKKED|PF_SPINNING
					end
				end
			end
			if ((player.mo.state == S_PLAY_BOUNCE_LANDING or ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.pflags & PF_BOUNCING or player.momentumplusbouncelast))))
				if not (player.weapondelay)
					fangbomb = P_SpawnMobjFromMobj(player.mo,5*FRACUNIT,5*FRACUNIT,player.mo.height+5*FRACUNIT,MT_FBOMB)
					fangbomb.target = player.mo
					fangbomb.momz = 10*FRACUNIT
					player.weapondelay = 6
					S_StartSound(player.mo, sfx_s3k51)
				end
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
					elseif not (player.mo.eflags & MFE_UNDERWATER) and (player.powers[pw_super] or player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER and (player.powers[pw_super] or player.powers[pw_sneakers]))
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					end
				end
			end
			if (P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING)
				player.pflags = $|PF_JUMPDOWN
				if (player.cmd.buttons & BT_JUMP and not (player.plusbuttons & BT_JUMP))
					P_DoJump(player, false)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					S_StartSound(player.mo, sfx_jump)
				end
			end
		end
		if (player.mo.skin == "metalsonic")
			if (player.dashmode < TICRATE and player.mo.state != S_PLAY_SPINDASH)
				player.dashmode = TICRATE
			elseif (player.dashmode < 3*TICRATE and player.mo.state == S_PLAY_SPINDASH and P_IsObjectOnGround(player.mo))
				if not (maptol & TOL_NIGHTS)
					player.dashmode = 3*TICRATE
					S_StartSound(player.mo, sfx_kc4d)
				end
			end
			if (player.secondjump)
				player.pflags = $ | PF_JUMPED | PF_THOKKED
				player.secondjump = 2
				player.mo.flags = $ | MF_NOGRAVITY
				if (player.speed < player.runspeed)
					player.mo.state = S_PLAY_FLOAT
				elseif (player.speed >= player.runspeed and not (player.dashmode >= 3*TICRATE))
					player.mo.state = S_PLAY_FLOAT_RUN
				elseif (player.speed >= player.runspeed and player.dashmode >= 3*TICRATE)
					player.mo.state = S_PLAY_DASH
				end
				if (player.cmd.buttons & BT_JUMP and not (player.cmd.buttons & BT_SPIN))
					if P_MobjFlip(player.mo)*player.mo.momz < 5*FRACUNIT
						P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
					elseif P_MobjFlip(player.mo)*player.mo.momz > 5*FRACUNIT
						P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
					end
				elseif (player.cmd.buttons & BT_SPIN and not (player.cmd.buttons & BT_JUMP))
					if P_MobjFlip(player.mo)*player.mo.momz > -(5*FRACUNIT)
						P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
					elseif P_MobjFlip(player.mo)*player.mo.momz < -(5*FRACUNIT)
						P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
					end
				elseif (not (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_SPIN))
					if P_MobjFlip(player.mo)*player.mo.momz > 0
						P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
					elseif P_MobjFlip(player.mo)*player.mo.momz < 0
						P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
					end
				elseif (player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN)
					player.mo.state = S_PLAY_JUMP
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					player.secondjump = 0
				end
			elseif not (player.secondjump)
				player.mo.flags = $ & ~MF_NOGRAVITY
			end
		end
		if (player.mo.skin == "vector" and player.pflags & PF_THOKKED and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL))
			player.mo.state = S_PLAY_JUMP
			player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
		end
		if (player.mo.skin == "heavy" and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH) and player.mo.heavyvars.tics > 3)
			player.mo.heavyvars.tics = 3
		end
		if (player.mo.skin == "bomb" and P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING and player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and not (player.mo.bomb_volatile) and player.mo.state != S_PLAY_SPINDASH)
			player.mo.state = S_PLAY_SPINDASH
			player.pflags = $|PF_SPINNING|PF_STARTDASH
			player.mo.bomb_fusedash = true
			player.mo.bomb_fusedash_charge = 1
			player.mo.bomb_fusedash_frame = 0
			player.mo.bomb_fusedash_frametics = 3
			S_StartSound(mo, sfx_sc0a5h)
		end
		if (player.mo.skin == "shadow" and P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING and player.mo.state != S_PLAY_ROLL and player.mo.state != S_PLAY_SPINDASH)
			player.mo.state = S_PLAY_ROLL
		end
	end
	player.momentumplusbouncelast = (player.pflags & PF_BOUNCING > 0)
	player.plusbuttons = player.cmd.buttons
	player.pluslastspeed = player.speed
end)
addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "sonic" and not (player.pflags & PF_THOKKED))
		if (player.mo.state != S_PLAY_JUMP)
			player.mo.state = S_PLAY_JUMP
		end
		if (player.cmd.forwardmove or player.cmd.sidemove)
			P_InstaThrust(player.mo, player.mo.angle, player.actionspd)
		end
		S_StartSound(player.mo, sfx_thok)
		P_SpawnThokMobj(player)
		if (player.cmd.buttons & BT_SPIN)
			player.pflags = $|PF_SPINNING|PF_THOKKED
			player.pflags = $ & ~(PF_STARTJUMP)
			P_SetObjectMomZ(player.mo, -(player.actionspd/5), false)
		else
			P_SetObjectMomZ(player.mo, player.actionspd/5, false)
			player.pflags = $|PF_SPINNING|PF_THOKKED|PF_STARTJUMP
		end
	end
end)
addHook("MobjDamage", function(enemy, mo, source)
	if ((mo and mo.valid) and not (P_IsObjectOnGround(mo)) and not (mo.eflags & MFE_JUSTHITFLOOR) and (mo.skin == "sonic" or mo.skin == "tails" or mo.skin == "knuckles" or mo.skin == "amy" or mo.skin == "fang" or mo.skin == "metalsonic" or mo.skin == "espio" or mo.skin == "mighty" or mo.skin == "charmy" or mo.skin == "vector" or mo.skin == "heavy" or mo.skin == "bomb" or mo.skin == "ray" or mo.skin == "shadow"))
		if ((enemy and enemy.valid) and (mo.state == S_PLAY_TWINSPIN or mo.state == S_PLAY_JUMP or mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL or mo.state == S_PLAY_ROLL or (mo.skin == "espio" and mo.state == S_ESPIO_ROLL) or (mo.skin == "bomb" and (mo.state == S_BOMB_TOPSPIN or mo.state == S_BOMB_TOPSPIN_FAST))))
			mo.player.pflags = $ & ~(PF_THOKKED|PF_SPINNING|PF_SHIELDABILITY)
			mo.player.pflags = $ | PF_JUMPED
		end
	end
end)
addHook("MobjDeath", function(enemy, mo, source)
	if ((mo and mo.valid) and not (P_IsObjectOnGround(mo)) and not (mo.eflags & MFE_JUSTHITFLOOR) and (mo.skin == "sonic" or mo.skin == "tails" or mo.skin == "knuckles" or mo.skin == "amy" or mo.skin == "fang" or mo.skin == "metalsonic" or mo.skin == "espio" or mo.skin == "mighty" or mo.skin == "charmy" or mo.skin == "vector" or mo.skin == "heavy" or mo.skin == "bomb" or mo.skin == "ray" or mo.skin == "shadow"))
		if ((enemy and enemy.valid) and (mo.state == S_PLAY_TWINSPIN or mo.state == S_PLAY_JUMP or mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL or mo.state == S_PLAY_ROLL or (mo.skin == "espio" and mo.state == S_ESPIO_ROLL) or (mo.skin == "bomb" and (mo.state == S_BOMB_TOPSPIN or mo.state == S_BOMB_TOPSPIN_FAST))))
			mo.player.pflags = $ & ~(PF_THOKKED|PF_SPINNING|PF_SHIELDABILITY)
			mo.player.pflags = $ | PF_JUMPED
		end
	end
end)